Qt Reference Documentation

# QAbstractState Class Reference

The QAbstractState class is the base class of states of a QStateMachine. More...

     #include <QAbstractState>

Inherits: QObject.

Inherited by: QFinalState, QHistoryState, and QState.

This class was introduced in Qt 4.6.

- List of all members, including inherited members

## Public Functions

| ~QAbstractState ()
QStateMachine * | machine () const
QState * | parentState () const

- 29 public functions inherited from QObject

## Signals

void | entered ()
void | exited ()

- 1 signal inherited from QObject

## Protected Functions

| QAbstractState ( QState * parent = 0 )
virtual void | onEntry ( QEvent * event ) = 0
virtual void | onExit ( QEvent * event ) = 0

## Reimplemented Protected Functions

virtual bool | event ( QEvent * e )

- 8 protected functions inherited from QObject

### Additional Inherited Members

- 1 property inherited from QObject
- 1 public slot inherited from QObject
- 7 static public members inherited from QObject

## Detailed Description

The QAbstractState class is the base class of states of a QStateMachine.

The QAbstractState class is the abstract base class of states that are part of a QStateMachine. It defines the interface that all state objects have in common. QAbstractState is part of The State Machine Framework.

The entered() signal is emitted when the state has been entered. The exited() signal is emitted when the state has been exited.

The parentState() function returns the state's parent state. The machine() function returns the state machine that the state is part of.

### Subclassing

The onEntry() function is called when the state is entered; reimplement this function to perform custom processing when the state is entered.

The onExit() function is called when the state is exited; reimplement this function to perform custom processing when the state is exited.

## Member Function Documentation

### QAbstractState::QAbstractState ( QState * parent = 0 )`[protected]`

Constructs a new state with the given parent state.

### QAbstractState::~QAbstractState ()

Destroys this state.

### void QAbstractState::entered ()`[signal]`

This signal is emitted when the state has been entered (after onEntry() has been called).

### bool QAbstractState::event ( QEvent * e )`[virtual protected]`

Reimplemented from QObject::event().

### void QAbstractState::exited ()`[signal]`

This signal is emitted when the state has been exited (after onExit() has been called).

### QStateMachine * QAbstractState::machine () const

Returns the state machine that this state is part of, or 0 if the state is not part of a state machine.

### void QAbstractState::onEntry ( QEvent * event )`[pure virtual protected]`

This function is called when the state is entered. The given event is what caused the state to be entered. Reimplement this function to perform custom processing when the state is entered.

### void QAbstractState::onExit ( QEvent * event )`[pure virtual protected]`

This function is called when the state is exited. The given event is what caused the state to be exited. Reimplement this function to perform custom processing when the state is exited.

### QState * QAbstractState::parentState () const

Returns this state's parent state, or 0 if the state has no parent state.